import { CacheData } from "./types";
import DatabaseDriverInterface from "./DatabaseDriverInterface";
export declare class DatabaseManager implements DatabaseDriverInterface {
    /**
     * Database Driver Engine
     *
     * @var {DatabaseDriverInterface}
     */
    private driver;
    /**
     * Set driver engine
     *
     * @param DatabaseDriverInterface driver
     */
    setDriver(driver: DatabaseDriverInterface): void;
    /**
     * Get driver engine
     *
     * @returns {DatabaseDriverInterface}
     */
    getDriver(): DatabaseDriverInterface;
    /**
     * Set database into storage
     * @param {string} key
     * @param {any} value
     */
    set(key: string, value: any): Promise<any>;
    /**
     * Get value from database engine,
     * If the key doesn't exist and the cachingData callback
     *
     * @param {string} key
     * @param {CacheData} cachingData
     */
    get(key: string, cachingData?: CacheData): Promise<any>;
    /**
     * Remove the given key from the database storage
     *
     * @param  {string} key
     */
    remove(key: string): Promise<any>;
    /**
     * Clear all data in database
     */
    flush(): void;
    /**
     * Clear all data in database
     */
    clear(): void;
}
declare const database: DatabaseManager;
export default database;
//# sourceMappingURL=DatabaseManager.d.ts.map