import { CacheData } from "../types";
import DatabaseDriverInterface from "../DatabaseDriverInterface";
export default class LocalForageDatabaseEngine implements DatabaseDriverInterface {
    /**
     * Set the storage engine
     */
    storage: any;
    /**
     * Prefix key
     */
    prefixKey: string;
    /**
     * Constructor
     */
    constructor(name: string, storeName: string);
    /**
     * Set data into storage engine
     * @param {string} key
     * @param {value} value
     */
    set(key: string, value: any): Promise<any>;
    /**
     * Get vale from storage engine
     *
     * @param   {string} key
     * @param   {CacheData} cacheData
     * @returns {any}
     */
    get(key: string, cacheData: CacheData): Promise<any>;
    /**
     * Remove key from storage
     *
     * @param  {string} key
     */
    remove(key: string): Promise<any>;
    /**
     * Get a proper key
     *
     * @param {string} key
     * @returns {string}
     */
    getKey(key: string): string;
    /**
     * Clear all data in database
     */
    flush(): void;
    /**
     * Clear all data in database
     */
    clear(): void;
    /**
     * Get prefix key
     *
     * @returns {string}
     */
    getPrefixKey(): string;
    /**
     * Set prefix key
     *
     * @returns {DatabaseDriverInterface}
     */
    setPrefixKey(prefixKey: string): DatabaseDriverInterface;
    /**
     * Data fetcher method to get the value from the database
     * If the value doesn't exists and the cacheData method is passed,
     * then grab it and store the data then return it
     */
    protected dataFetcher(key: string, valueHandler: (value: any) => any, cacheData?: any): Promise<unknown>;
}
//# sourceMappingURL=LocalForageDatabaseEngine.d.ts.map